#ifndef ZASM_LINKER_H
#define ZASM_LINKER_H 1

#include <zasm/stream.h>
#include <zasm/feeder.h>
#include <zasm/expr.h>
#include <zasm/link_namespace.h>

#define INT_ALLOC_T(O) ((struct int_alloc_t *)(O))
struct int_alloc_t
{
  struct int_alloc_t *previous;
  int i;
  int data[1024];
};

#define LINKER_T(O) ((struct linker_t *)(O))
struct linker_t
{
  struct token_t look_ahead;
  int address;
  int instr_start;
  int page;
  int page_start;
  struct link_namespace_t *ns;
  struct expr_alloc_t *expr_alloc;
  struct int_alloc_t *int_alloc;
  char *dump_file;
  char *export_file;
  struct list_t *dump_labels;
  struct list_t *export_labels;
};

struct linker_t *linker_new(char *dump_file, char *export_file);
void linker_fill(struct linker_t *lnk, char *dump_file, char *export_file);
int *linker_get_int(struct linker_t *lnk);
void linker_execute(struct feeder_t *input, struct stream_t *output, struct linker_t *lnk);
void linker_delete(struct linker_t *lnk);
void linker_free(struct linker_t *lnk);

struct int_alloc_t *int_alloc_new();
void int_alloc_fill(struct int_alloc_t *a);
int *int_alloc_get(struct int_alloc_t **a);
void int_alloc_reset(struct int_alloc_t *a);
void int_alloc_delete(struct int_alloc_t *a);
void int_alloc_free(struct int_alloc_t *a);

#endif
