#define ZASM_STR_C 1

#include <zasm/str.h>
#include <zasm/memory.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>

char *str_concat(char *str0, ...)
{
  static char *str = NULL;
  char *stri;
  int i = 0;
  static int n = 0;
  int l;
  va_list ap;

  va_start(ap, str0);
  for (stri = str0; stri; stri = va_arg(ap, char *))
    {
      l = strlen(stri);
      if (i+l >= n)
	{
	  n = i+l+1;
	  REALLOCATE(char, str, n);
	}
      strcpy(str+i, stri);
      i += l;
    }
  va_end(ap);
  return str;
}

char *str_append_int(char *str, int i)
{
  char str1[16]; // enough for 32 bit integers
  snprintf(str1,16,"%i",i);
  return STR_CONCAT(str,str1);
}

char *str_prepend_int(int i, char *str)
{
  char str1[16]; // enough for 32 bit integers
  snprintf(str1,16,"%i",i);
  return STR_CONCAT(str1,str);
}

char *str_get_path(char *file)
{
  int i,l;
  char *val;
  l = -1;
  for (i = 0; file[i]; i++)
    if (file[i] == '/')
      l = i;
  ALLOCATE(char, val, l+2);
  memcpy(val, file, (l+1)*sizeof(char));
  val[l+1] = 0;
  return val;
}
