#!/usr/bin/perl

my %info = ();
my $current = undef;

open(RELEASE, "<release.rel");
REL: while (<RELEASE>)
{
    if (!defined($current))
    {
	if (/^.*?<\s*(\w+)\s*>(.*)$/)
	{
	    $current = $1;
	    $_ = $2;
	    redo REL;
	}
    }
    else
    {
	if (/^(.*?)<\s*\/\s*$current\s*>(.*)$/)
	{
	    $info{$current}.=$1;
	    undef $current;
	    $_ = $2;
	    redo REL;
	}
	else
	{
	    $info{$current}.=$_;
	}
    }
}
close(RELEASE);

open(HTMLIN, "<index.html.rel");
open(HTMLOUT, ">index.html");
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
my $today = sprintf("%04d-%02d-%02d",$year+1900,$mon+1,$mday);

HTML: while (<HTMLIN>)
{
    s/(<!--\s*<\s*news\s*>\s*-->)/$1\n    <dt>$time<\/dt>\n    <dd>\n      <p>\n$info{"news"}      <\/p>\n    <\/dd>/g;
    s/(<!--\s*<\s*link\s*>\s*-->)/$1\n    <dt>$info{"longversion"}<\/dt>\n    <dd><a href=\"zasm-$info{"version"}.tar.bz2\">download<\/a><\/dd>/g;
    if (exists($info{"bugs"}))
    {
	s/(<!--\s*<\s*bugs\s*>\s*-->)/$1\n    $info{"bugs"}/g;
    }
    print HTMLOUT $_;
}
close(HTMLIN);
close(HTMLOUT);

systemp("cp index.html index.html.rel");

my @devels = ();
chdir("..");
opendir(DIR,".");
my @develstmp = readdir(DIR);
foreach (@develstmp)
{
    push(@devels,$1) if (/zasm-0.1-devel-(\d+).tar.bz2/);
}
closedir(DIR);
my $devel = max(@devels)+1;
systemp("tar -cjf zasm-0.1-devel-$devel.tar.bz2 zasm-0.1-devel");

if (!isin("zasm-$info{'version'}", develstmp))
{
    systemp("mkdir zasm-$info{'version'}");
}
systemp("cp -R zasm-0.1-devel/* zasm-$info{'version'}");
systemp("zasm-$info{'version'}/configure");
systemp("make -C zasm-$info{'version'} distribution");
systemp("tar -cjf zasm-$info{'version'}.tar.bz2 zasm-$info{'version'}");
systemp("make -C zasm-0.1-devel veryclean");
systemp("tar -cjf zasm-0.1-devel.tar.bz2 zasm-0.1-devel");
systemp('echo -e "cd prj_zasm\nput zasm-0.1-devel.tar.bz2\nput zasm-'.$info{'version'}.
	'.tar.bz2\nquit\n" | ftp ticalc.org');
chdir("zasm-0.1-devel");
sustemp('echo -e "cd prj_zasm\nput index.html\nquit\n" | ftp ticalc.org');

sub systemp
{
    my $com = shift;
    print($com,"\n");
    system($com);
}

sub max
{
    my $val = shift;
    foreach (@_)
    {
	$val = $_ if ($_>$val);
    }
    $val;
}

sub isin
{
    my $val = shift;
    foreach (@_)
    {
	return true if ($_==$val);
    }
    return false;
}
