#ifndef ZASM_ERRORS_H
#define ZASM_ERRORS_H 1

//#define PLACE DEBUG("(in file \"%s\", function \"%s\", line %i):\n", __FILE__, __FUNCTION__, __LINE__)
#define PLACE 

#include <zasm/tokens.h>

#ifndef ZASM_ERRORS_NO_SHORT

#define T_ERROR(token, format, args...) (({PLACE;error_print_error_token(token, format, ## args);}))
#define T_WARNING(token, format, args...) (({PLACE;error_print_warning_token(token, format, ## args);}))
#define T_DEBUG(token, format, args...) (({PLACE;error_print_debug_token(token, format, ## args);}))

#define ERROR(format, args...) (({PLACE;error_print_error(format, ## args);}))
#define WARNING(format, args...) (({PLACE;error_print_warning(format, ## args);}))
#define DEBUG(format, args...) (({error_print_debug(format, ## args);}))

#endif

void error_init(int *argc_p, char ***argv_p);
void error_print_error_token(struct token_t token, char *format, ...);
void error_print_warning_token(struct token_t token, char *format, ...);
void error_print_debug_token(struct token_t token, char *format, ...);
void error_print_error(char *format, ...);
void error_print_warning(char *format, ...);
void error_print_debug(char *format, ...);

#endif
