#include <ti83plus.inc>
.export PushMCplxO1
.export PopMCplxO1
.export SaveCplxO1
.export LoadCplxO1
.export CopyCplx
.export LoadReal
.export SaveReal
.export ExportReal
	
;; some functions that do not exist in the include file
PushMCplxO1:
	B_CALL PushRealO1
	B_CALL PushRealO2
	ret

PopMCplxO1:
	B_CALL PopRealO2
	B_CALL PopRealO1	
	ret

;; arguments: de:	destination
;; registers destroyed:	hl,de,bc,f
SaveCplxO1:
	ld hl,OP1
	ld bc,9
	ldir
	ld hl,OP2
	ld bc,9
	ldir
	ret

;; arguments: hl:	source
;; registers destroyed:	hl,de,bc,f
LoadCplxO1:
	push hl
	ld hl,OP1
	ld de,OP1+1
	ld (hl),0
	ld bc,21
	ldir
	pop hl
	ld de,OP1
	ld bc,9
	ldir
	ld de,OP2
	ld bc,9
	ldir
	ret

;; arguments:	hl:	source
;;		de:	destination
CopyCplx:
	ld bc,18
	ldir
	ret

;; arguments:	hl:	 source
;;		de:	 destination
LoadReal:
	ld bc,9
	ldir
	ld a,0
	ld (de),a
	inc de
	ld (de),a
	ret

;; arguments:	hl:	source
;;		de:	dest
SaveReal:
	ld bc,9
	ldir
	ret

;; writes the real number in OP1 as a complex number
;; arguments:	de:	destination
;;		hl:	source
ExportReal:
	ld a,(hl)
	or 0x0C
	ld (de),a
	inc de
	inc hl
	ld bc,8
	ldir
	ld hl,Imaginary0
	ld bc,9
	ldir
	ret

Imaginary0:
	.db 0x0C, 0x80, 0, 0, 0, 0, 0, 0, 0
