; Title:        Battle Ship
; Author:       Michael Bruno (mikebruno@cox.net)
; Version:      1.96
; Platform:     MirageOS
; Date:         5/27/2004
;---------------------------------------
; Copyright (C) 2003, 2004 Michael Bruno
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;---------------------------------------

#define blinkdelay      saferam1
#define spoty           saferam1+       1
#define spotx           saferam1+       2
#define spotstatus      saferam1+       3
#define shiplength      saferam1+       4
#define shipdirection   saferam1+       5
#define piecesize0      saferam1+       6
#define piecesize1      saferam1+       7
#define piecesize2      saferam1+       8
#define piecesize3      saferam1+       9
#define piecesize4      saferam1+       10
#define totalleft       saferam1+       11
#define AIpiecesize0    saferam1+       12
#define AIpiecesize1    saferam1+       13
#define AIpiecesize2    saferam1+       14
#define AIpiecesize3    saferam1+       15
#define AIpiecesize4    saferam1+       16
#define AItotalleft     saferam1+       17
#define curpiece        saferam1+       18
#define setready        saferam1+       19
#define AIy1            saferam1+       20
#define AIx1            saferam1+       21
#define AIy2            saferam1+       22
#define AIx2            saferam1+       23
#define AIsinking       saferam1+       24
#define AIdir           saferam1+       25
#define temp            saferam1+       26
#define tspoty          saferam1+       27
#define tspotx          saferam1+       28
#define gamearea1       saferam1+       29
#define gamearea2       saferam1+       129
#define gamearea1AI     saferam1+       229
#define gamearea2AI     saferam1+       329

;gamearea1 and 1ai:     Grid with your ships and opponents hits on it
;                       bits 2 thru 0 are piece number
;                       bit 3 is if it is a ship
;                       bit 4 is if it is hit
;                       bits 7 thru 5 are piece type (mid, left, right, top, bottom)

;gamearea2 and 2ai:     Grid with your hits and misses on it
;                       1 is miss. 2 is hit



FKDown          .equ 254
FKLeft          .equ 253
FKRight         .equ 251
FKUp            .equ 247
Group1          .equ $FE
FKClear         .equ 191
Group2          .equ $FD



;---------------= header =--------------
#include        "ti83plus.inc"                  ;General TI-83 Plus include file
#include        "mirage.inc"                    ;MirageOS include file
        .org    $9d93                           ;Origin (set back two to account for AsmPrgm)
        .db     $BB,$6D                         ;Compiled AsmPrgm token
        ret                                     ;So TIOS wont run the program
        .db     1                               ;Identifier as MirageOS program
        
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000001, %00000000
        .db %00000001, %01000000
        .db %10000111, %11110010
        .db %11111111, %11111110
        .db %01111111, %11111100
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        .db %00000000, %00000000
        
        .db     "BattleShip! v1.96",0

;---------------= begin =--------------
start:
        set     textWrite,(IY+sGrFlags)
        bcall(_RunIndicOff)             ;initial settings
        bcall(_GrBufClr)
        ld      de,0*256+17
        ld      (penCol),de
        set     fracDrawLFont,(IY+fontFlags)
        ld      hl,titlestr
        bcall(_VPutS)                   ;write the title
        res     fracDrawLFont,(IY+fontFlags)
        ld      bc,0*256+55
        ld      de,94*256+55
        bcall(_DarkLine)                ;draw line
        ld      de,10*256+1
        ld      (penCol),de
        ld      hl,authorstr
        bcall(_VPutS)                   ;write my name
        ld      de,22*256+4
        ld      (penCol),de
        ld      hl,startstr
        bcall(_VPutS)                   ;write "2nd - Start"
        ld      de,29*256+4
        ld      (penCol),de
        ld      hl,quitstr
        bcall(_VPutS)                   ;write "Mode - Quit"
        ld      de,36*256+4
        ld      (penCol),de
        ld      hl,playersstr
        bcall(_VPutS)                   ;write "Alpha - Players:"
        ld      hl,players
        bcall(_VPutS)                   ;write number of players
        ld      l,45
        ld      a,5
        call    drawship
        call    ifastcopy

;---------= main program=--------
menuloop:
        bcall(_GetCSC)
        cp      skMode
        ret     z
        cp      skClear
        ret     z
        cp      skAlpha
        jr      z,changeplayers
        cp      sk2nd
        jr      z,setships
        jp      menuloop

changeplayers:
        ld      hl,players
        ld      a,(hl)
        sub     49                      ;("1")
        jr      z,set2
        dec     (hl)
        jp      start
set2:
        inc     (hl)
        jp      start

setships:
        ld      hl,AIsinking
        ld      de,AIsinking+1
        ld      bc,402
        ld      (hl),0
        ldir
        
        ld      hl,piecesize0
        ld      (hl),5
        inc     hl
        ld      (hl),4
        inc     hl
        ld      (hl),3
        inc     hl
        ld      (hl),3
        inc     hl
        ld      (hl),2
        inc     hl
        ld      (hl),5
        inc     hl
        ld      (hl),5
        inc     hl
        ld      (hl),4
        inc     hl
        ld      (hl),3
        inc     hl
        ld      (hl),3
        inc     hl
        ld      (hl),2
        inc     hl
        ld      (hl),5
        ld      a,1
        ld      (temp),a

        bcall(_GrBufClr)
        ld      l,57
        ld      a,64
        call    drawship
        call    drawgrid
        ld      hl,0*256+0
        ld      (spoty),hl
        ld      d,0
        ld      hl,piecesize0
        ld      e,(hl)
        ld      hl,curpiece
        ld      (hl),0
        ld      (shiplength),de
        call    drawpiece
        call    ifastcopy
keyloop0:
        bcall(_GetCSC)
        cp      skDown
        jp      z,shipdown
        cp      skUp
        jp      z,shipup
        cp      skRight
        jp      z,shipright
        cp      skLeft
        jp      z,shipleft
        cp      sk2nd
        jp      z,flipship
        cp      skMode
        jp      z,quit
        cp      skEnter
        jp      z,placeship
        jr      keyloop0

shipdown:
        ld      a,(shipdirection)
        or      a
        ld      a,(spoty)
        jr      z,skipdowncompensate
        ld      hl,shiplength
        ld      b,(hl)
        dec     b
        add     a,b
skipdowncompensate:
        cp      9
        jp      z,keyloop0
        call    drawpiece
        ld      a,(spoty)
        inc     a
        ld      (spoty),a
        call    drawpiece
        call    ifastcopy
        jp      keyloop0
shipup:
        ld      a,(spoty)
        or      a
        jp      z,keyloop0
        call    drawpiece
        ld      a,(spoty)
        dec     a
        ld      (spoty),a
        call    drawpiece
        call    ifastcopy
        jp      keyloop0
shipright:
        ld      a,(shipdirection)
        or      a
        ld      a,(spotx)
        jr      nz,skiprightcompensate
        ld      hl,shiplength
        ld      b,(hl)
        dec     b
        add     a,b
skiprightcompensate:
        cp      9
        jp      z,keyloop0
        call    drawpiece
        ld      a,(spotx)
        inc     a
        ld      (spotx),a
        call    drawpiece
        call    ifastcopy
        jp      keyloop0
shipleft:
        ld      a,(spotx)
        or      a
        jp      z,keyloop0
        call    drawpiece
        ld      a,(spotx)
        dec     a
        ld      (spotx),a
        call    drawpiece
        call    ifastcopy
        jp      keyloop0
flipship:
        ld      a,(spotx)
        ld      hl,shiplength
        ld      b,(hl)
        add     a,b
        cp      11
        jp      nc,keyloop0
        ld      a,(spoty)
        ld      hl,shiplength
        ld      b,(hl)
        add     a,b
        cp      11
        jp      nc,keyloop0
        call    drawpiece
        ld      a,(shipdirection)
        cpl
        ld      (shipdirection),a
        
        call    drawpiece
        call    ifastcopy
        jp      keyloop0
        
placeship:                              ;saves the ship into gamearea1 and loads next piece  
        ld      a,(setready)
        or      a
        ld      bc,gamearea1
        jr      nz,readytoset
        jp      keyloop0
readytoset:
;----------------------------saving to gamearea1---
        ld      hl,(spoty)
        ld      de,(shiplength)
        inc     d
        dec     d
        jr      z,saveleft              ;check direction of the piece
        ld      a,1                     ;if vertical load the top sprite
        jr      saveloop                ;go save it
saveleft:
        ld      a,4                     ;but if it's horizonal load the left sprite
saveloop:
        push    hl
        push    de
        push    bc
        
        rrca
        rrca
        rrca                            ;moves bits 2thru0 to 7thru5
        ex      de,hl
        ld      hl,curpiece
        or      (hl)
        or      8
        ld      h,b                     ;bc is gamearea.
        ld      l,c
        ld      c,1                     ;c=1 means save spot
        call    gameareamem
        
        pop     bc
        pop     de
        pop     hl
        
        dec     e
        inc     d
        dec     d
        jr      z,horiz                 ;check direction of the piece
        inc     l                       ;if vertical move the position down
        ld      a,e
        cp      1
        jr      z,savebottom            ;if last piece, save bottom piece data
        or      a
        jp      z,nextpiece             ;leave if it already saved the last piece
        xor     a
        jr      saveloop                ;loop back to save
horiz:
        inc     h                       ;if horizontal move the position right
        ld      a,e
        cp      1
        jr      z,saveright             ;if last piece, save right piece data
        or      a
        jp      z,nextpiece             ;leave if it already saved the last piece
        xor     a
        jr      saveloop                ;loop back to save
savebottom:
        ld      a,2
        jp      saveloop
saveright:
        ld      a,3
        jp      saveloop
;----------------------------------------------------
        
nextpiece:
        ld      a,(curpiece)
        cp      4
        jr      z,waitscreen            ;go sync up with player2 if done setting ships

        ld      hl,curpiece
        inc     (hl)
        ld      c,(hl)                  ;load up next piece
        ld      hl,piecesize0
        ld      b,0
        add     hl,bc                   ;add the current piece number to address of piecesize0
        ld      c,(hl)                  ;and load its size into bc
        
        ld      (shiplength),bc         ;and then into shiplength..
        ld      a,(temp)
        or      a
        jp      z,placeshipsloopAI      ;if it's AI's turn we jump back to its routine so it can pick next spot
        ld      hl,0*256+0
        ld      (spoty),hl
        call    drawpiece
        call    ifastcopy
        jp      keyloop0
        

waitscreen:
		ld      de,0
        ld      (tspoty),de
        ld      a,(players)
        cp      50                      ;("2")
        jp      z,continuewait
        ld      a,(temp)
        or      a
        jp      z,skiplinkcheck
        jp      setshipsAI
continuewait:        
        bcall(_ClrLCDFull)
        ld      de,0
        ld      (currow),de
        ld      hl,waitstr
        bcall(_PutS)
        ld      a,2
        call    sendbytetios
waitloop:
        bcall(_GetCSC)
        cp      skMode
        jp      z,quit
        call    checklink
        jr      z,waitloop
        call    getbytetios
        cp      2
        jr      z,player1
        cp      1
        jp      z,oppturn
        jr      waitloop
player1:
        ld      a,1
        call    sendbytetios
        jr      skiplinkcheck

pickspot:
        call    ifastcopy
        call    checklink
        jr      z,pickspot
        call    getbytetios
skiplinkcheck:
        ;ld      de,1*256+1
        ;ld      (spoty),de
        bcall(_GrBufClr)
        ld      l,57
        ld      a,64
        call    drawship
        call    drawgrid
        
;------------------------------------draw hits and misses
        ld      hl,gamearea2-1
        ld      de,-1*256+0
hitmissloop:
        inc     hl
        inc     d
        push    hl
        push    de
        ld      c,(hl)
        ld      a,d
        ld      l,e
        call    loctopix                ;al=pixels for sprite. c=hit or miss. de=x,y
        dec     c
        jr      z,drawmiss
        dec     c
        jr      z,drawhit
        jr      continuehitmiss
drawmiss:
        ld      b,5
        ld      ix,miss
        call    isprite
        jr      continuehitmiss
drawhit:
        ld      b,5
        ld      ix,hit
        call    isprite
continuehitmiss:
        pop     de
        pop     hl
        ld      a,d
        add     a,e
        cp      18
        jr      z,endhitmissloop
        ld      a,d
        cp      9
        jr      nz,hitmissloop
        inc     e
        ld      d,-1
        jr      hitmissloop
endhitmissloop:

        ld      a,0
        ld      (spotstatus),a
keyloop1:
        call    blinkspot
        bcall(_GetCSC)
        cp      skDown
        jp      z,spotdown
        cp      skUp
        jp      z,spotup
        cp      skRight
        jp      z,spotright
        cp      skLeft
        jp      z,spotleft
        cp      skMode
        jp      z,quit
        cp      skEnter
        jp      z,testspot
        cp      sk2nd
        jp      z,testspot
        jr      keyloop1
        
spotdown:
        ld      a,(tspoty)
        cp      9
        jp      z,keyloop1
        ld      a,(spotstatus)
        or      a
        call    nz,blinkspot
        ld      a,(tspoty)
        inc     a
        ld      (tspoty),a
        jp      keyloop1
spotup:
        ld      a,(tspoty)
        or      a
        jp      z,keyloop1
        ld      a,(spotstatus)
        or      a
        call    nz,blinkspot
        ld      a,(tspoty)
        dec     a
        ld      (tspoty),a
        jp      keyloop1
spotright:
        ld      a,(tspotx)
        cp      9
        jp      z,keyloop1
        ld      a,(spotstatus)
        or      a
        call    nz,blinkspot
        ld      a,(tspotx)
        inc     a
        ld      (tspotx),a
        jp      keyloop1
spotleft:
        ld      a,(tspotx)
        or      a
        jp      z,keyloop1
        ld      a,(spotstatus)
        or      a
        call    nz,blinkspot
        ld      a,(tspotx)
        dec     a
        ld      (tspotx),a
        jp      keyloop1

testspot:
        ld      de,(tspoty)
        ld      c,0                     ;c=0 means get spot
        ld      hl,gamearea2
        call    gameareamem
        or      a
        jp      nz,keyloop1
        ld      a,(players)
        cp      50                      ;("2")
        jr      z,testspotLink
        ld      de,21*256+65
        ld      (penCol),de
        ld      de,(tspoty)
        ld      c,0                     ;c=0 means get spot
        ld      hl,gamearea1AI
        call    gameareamem
        ld      b,a
        and     %00001000
        jr      z,youmissed
        ld      a,b
        and     %00000111
        ld      hl,piecesize0
        ld      c,a
        ld      b,0
        add     hl,bc
        dec     (hl)
        jr      nz,youhit
        ld      hl,totalleft
        dec     (hl)
        jp      z,youwin
        jr      yousunk
        
testspotLink:
        ld      a,(tspotx)
        rrca
        rrca
        rrca
        rrca
        ld      b,a
        ld      a,(tspoty)
        or      b
        call    sendbytetios
testspotloop:
        call    checklink
        jr      z,testspotloop
        call    getbytetios
        ld      de,21*256+65
        ld      (penCol),de
        dec     a
        jr      z,youmissed
        dec     a
        jr      z,youhit
        dec     a
        jp      z,youwin
        
yousunk:
        ld      hl,hitstr
        bcall(_VPutS)
        ld      de,28*256+65
        ld      (penCol),de
        ld      hl,sunkstr
        bcall(_VPutS)
        jr      skiphittext
youmissed:
        ld      hl,missstr
        bcall(_VPuts)
        ld      de,(tspoty)
        ld      c,1                     ;c=1 means save spot
        ld      a,1                     ;setting this spot as a miss
        ld      hl,gamearea2
        call    gameareamem
        ld      ix,miss
        jp      endturn
youhit:
        ld      hl,hitstr
        bcall(_VPutS)
skiphittext:
        ld      de,(tspoty)
        ld      c,1                     ;c=1 means save spot
        ld      a,2                     ;setting this spot as a hit
        ld      hl,gamearea2
        call    gameareamem
        ld      ix,hit
endturn:
        ld      hl,(tspoty)
        ld      a,h
        call    loctopix
        ld      b,5
        call    isprite
        call    ifastcopy
        call    waitforkey
        ld      a,(players)
        cp      49                      ;("1")
        jr      z,oppturn
        ld      a,1
        call    sendbytetios


oppturn:
        xor     a
        ld      (temp),a
drawmyships:
        bcall(_GrBufClr)
        
;------------------------------------draw your ships
        ld      hl,gamearea1-1
        ld      de,-1*256+0
drawshipsloop:
        inc     hl
        inc     d
        push    hl
        push    de
        ld      a,(hl)
        push    af
        bit     3,a
        jr      z,continuedrawships
        and     %11100000
        rlca
        rlca
        rlca
        inc     a
        ld      c,a
        ld      a,d
        ld      l,e
        call    loctopix                ;al=pixels for sprite. c=piece type. de=x,y
        ld      b,5
        dec     c
        jr      z,drawmiddle
        dec     c
        jr      z,drawup
        dec     c
        jr      z,drawdown
        dec     c
        jr      z,drawright
        dec     c
        jr      z,drawleft

drawmiddle:
        ld      ix,spot
        call    isprite
        jr      continuedrawships
drawup:
        ld      ix,toppiece
        call    isprite
        jr      continuedrawships
drawdown:
        ld      ix,bottompiece
        call    isprite
        jr      continuedrawships
drawright:
        ld      ix,rightpiece
        call    isprite
        jr      continuedrawships
drawleft:
        ld      ix,leftpiece
        call    isprite
continuedrawships:
        pop     af
        pop     de
        pop     hl
        and     %00010000
        jr      z,notHit
        push    hl
        push    de
        ld      a,d
        ld      l,e
        call    loctopix
        ld      b,5
        ld      ix,hit
        call    isprite
        pop     de
        pop     hl
notHit:
        ld      a,d
        add     a,e
        cp      18
        jr      z,enddrawshipsloop
        ld      a,d
        cp      9
        jr      nz,drawshipsloop
        inc     e
        ld      d,-1
        jr      drawshipsloop
enddrawshipsloop:
        ld      l,57
        ld      a,64
        call    drawship
        call    drawgrid
        
        ld      a,(temp)
        or      a
        ret     nz
        
        ld      a,(players)
        cp      50                      ;("2")
        jr      z,oppturnloop
        call    mainAI
        ld      a,(AItotalleft)
        or      a
        jp      z,youloseAI
        call    ifastcopy
        call    waitforkey
        jp      skiplinkcheck
        
oppturnloop:
        bcall(_GetCSC)
        cp      skMode
        jp      z,quit
        call checklink
        jr      z,oppturnloop
        call    getbytetios
        ld      b,a
        and     %00001111
        ld      (spoty),a
        ld      a,b
        rrca
        rrca
        rrca
        rrca
        and     %00001111
        ld      (spotx),a
        
        ld      de,(spoty)
        ld      c,0                     ;c=0 means get spot
        ld      hl,gamearea1
        call    gameareamem
        ld      c,1                     ;c=1 means save spot
        or      %00010000               ;setting this spot as a hit (even if it's a miss)
        ld      hl,gamearea1
        call    gameareamem
        ld      de,21*256+65
        ld      (penCol),de
        bit     3,a
        jr      z,hemissed
        push    af
        ld      hl,hitstr
        bcall(_VPutS)
        ld      hl,(spoty)
        ld      a,h
        call    loctopix
        ld      b,5
        ld      ix,hit
        call    isprite
        pop     af
        and     %00000111
        ld      hl,piecesize0
        ld      c,a
        ld      b,0
        add     hl,bc
        dec     (hl)
        jr      z,sunk
        ld      a,2
        call    sendbytetios
        jp      pickspot
sunk:
        ld      hl,totalleft
        dec     (hl)
        jp      z,youlose
        ld      a,4
        call    sendbytetios
        ld      de,28*256+65
        ld      (penCol),de
        ld      hl,sunkstr
        bcall(_VPutS)
        jp      pickspot
        
hemissed:
        ld      a,1
        call    sendbytetios
        ld      hl,missstr
        bcall(_VPutS)
        ld      hl,(spoty)
        ld      a,h
        call    loctopix
        ld      b,5
        ld      ix,hit
        call    isprite
        jp      pickspot
        
;---------------= AI Routines =--------------
;These get called instead of waiting for the
;opponent's calculator in 1 player mode.


setshipsAI:
;Explanation: chooses random direction. horiz or vert.
;based on this and the ship size, it sets the boundaries.
;from the boundaries it gets a random x,y location.
;checks for overlapping. repicks spots if needed.
;then it sets bc to gamearea1AI and jumps to readytoset
        xor     a
        ld      (temp),a
        ld      d,0
        ld      hl,AIpiecesize0
        ld      e,(hl)
        ld      hl,curpiece
        ld      (hl),0
        ld      (shiplength),de
placeshipsloopAI:
        ld      hl,shiplength
        ld      a,10
        sub     (hl)
        ld      b,a
        call    irandom
        ld      (spotx),a
        ld      b,10
        call    irandom
        ld      (spoty),a
        ld      b,2
        call    irandom
        ld      (shipdirection),a
        or      a
        jr      z,checkoverlaps                 ;if it goes vertical we want to swap coords
        ld      hl,spotx
        ld      b,(hl)
        dec     hl
        ld      a,(hl)
        ld      (hl),b
        inc     hl
        ld      (hl),a
checkoverlaps:
        ld      hl,(spoty)
        ld      de,(shiplength)
checkoverlaploop:
        push    hl
        push    de
        ex      de,hl
        ld      hl,gamearea1AI
        ld      c,0
        call    gameareamem
        pop     de
        pop     hl
        and     %00001000
        jr      nz,placeshipsloopAI
        dec     e                       ;decrease the length by 1
        jr      z,endcheckoverlap
        inc     d
        dec     d
        jr      z,incxAI                ;check direction of the piece
        inc     l                       ;if vertical move the position down
        jr      checkoverlaploop
incxAI:
        inc     h                       ;if horizontal move the position right
        jr      checkoverlaploop

endcheckoverlap:
        ld      bc,gamearea1AI
        jp      readytoset
        
        
mainAI:
        ld      a,2
        ld      (temp),a
        ld      a,(AIsinking)
        or      a
        jr      nz,continuesink         ;already sinking? continue that then
        ld      b,10
        call    irandom                 ;random x coord
        ld      d,a
        ld      b,10
        call    irandom                 ;random y coord
        ld      e,a
        ld      (spoty),de              ;save em
        
        ld      c,0                     ;get spot
        ld      hl,gamearea2AI
        call    gameareamem
        or      a                       ;checks to see if it's already been picked
        jr      nz,mainAI               ;and if it has try again
        ld      hl,gamearea1
        ld      c,0
        call    gameareamem             ;checking the player's grid for that spot
        call    setashit                ;and setting it as hit
        bit     3,a                     ;now checking to see if that spot was a hit or miss
        jr      nz,firsthit
        call    setAsMiss
        ret
firsthit:
        call    setAsHitCheckForSink
        jp      z,AIsunk                ;and if it sunk, reset and leave
        ld      (AIy1),de
        ld      (AIy2),de
        ld      a,1
        ld      (AIsinking),a
        ret
        
continuesink:
        ld      a,(AIdir)
        or      a
        jr      nz,continuedirection    ;already got a direction? keep going then
        ld      c,$FF
pickDirection:
        dec     c
        jp      z,AIrestart             ;if it's picked 256 directions and none are free, it restarts
                                        ;instead of getting stuck forever
        push    bc
        ld      b,4
        call    irandom
        inc     a                       ;1=right, 2=left, 3=up, 4=down
        ld      (AIdir),a
        ld      de,(AIy1)
        call    goDirection
        ld      c,0                     ;get spot
        ld      hl,gamearea2AI
        call    gameareamem             ;checking if already picked this spot
        pop     bc
        or      a
        jr      nz,pickDirection        ;if so try again
        ld      hl,gamearea1
        ld      c,0
        call    gameareamem             ;checking the player's grid for that spot
        call    setashit                ;and setting it as hit
        bit     3,a                     ;now checking to see if that spot was a hit or miss
        jr      nz,secondhit
        call    setAsMiss
        xor     a
        ld      (AIdir),a               ;and forgetting that direction
        ret
secondhit:
        call    setAsHitCheckForSink
        jr      z,AIsunk                ;and if it sunk, reset and leave
        ld      (AIy2),de
        ret

continuedirection:
        ld      de,(AIy2)
        call    goDirection             ;moves location in de in the current direction
        ld      (AIy2),de
        jp      z,switchEnds            ;if the zero flag was set this means it went off the grid
                                        ;so it jumps to switchends
        ld      c,0
        ld      hl,gamearea2AI
        call    gameareamem
        cp      1                       ;checking to see if already been hit and was a miss
        jr      z,switchEnds            ;if it is a miss then jump to switchends
        cp      2                       ;checking to see if already been hit and was a hit
        ld      a,(AIdir)
        jr      z,continuedirection     ;if it is a hit then jump back to move in direction again
        ld      hl,gamearea1
        ld      c,0
        call    gameareamem             ;checking the player's grid for that spot
        call    setashit                ;and setting it as hit
        bit     3,a                     ;now checking to see if that spot was a hit or miss
        jr      z,missedReverse
        call    setAsHitCheckForSink
        jr      z,AIsunk                ;and if it sunk, reset and leave
        ret

switchEnds:
        call    reverseDirection
        or      a    
        jr      z,pickDirection         ;if it gave 0 for the direction then pick a new one
        jp      continuedirection
        
AIsunk:
        ld      hl,AItotalleft
        dec     (hl)
        ld      de,28*256+65
        ld      (penCol),de
        ld      hl,sunkstr
        bcall(_VPutS)
        xor     a
        ld      (AIdir),a
        ld      (AIsinking),a
        ret
        
AIrestart:
        xor     a
        ld      (AIdir),a
        ld      (AIsinking),a
        jp      mainAI

missedReverse:
        call    setAsMiss
        call    reverseDirection
        ret

setAsHitCheckForSink:
        push    af
        push    de
        ld      a,2
        ld      c,1
        ld      hl,gamearea2AI
        call    gameareamem             ;a hit so remembering this
        ld      de,21*256+65
        ld      (penCol),de
        ld      hl,hitstr
        bcall(_VPutS)
        pop     de
        pop     af
        and     %00000111               ;gets the piece number that was hit
        ld      hl,AIpiecesize0
        ld      c,a
        ld      b,0
        add     hl,bc                   ;this adds the piece number to the address of
                                        ;AIpiecesize0 to get the address of the piece hit
        dec     (hl)
        ret

setAsMiss:
        ld      c,1
        ld      hl,gamearea2AI
        ld      a,1
        call    gameareamem             ;a miss so remembering this
        ld      de,21*256+65
        ld      (penCol),de
        ld      hl,missstr
        bcall(_VPutS)
        ret

setashit:
        push    af
        push    de
        call    waitforkey
        pop     hl
        push    hl
        ld      a,h
        call    loctopix
        ld      b,5
        ld      ix,hit
        call    isprite
        pop     de
        pop     af
        ld      c,1                     ;c=1 means save spot
        or      %00010000               ;setting this spot as a hit (even if it's a miss)
        ld      hl,gamearea1
        call    gameareamem
        ret

reverseDirection:                       ;reverses direction (a). if called a second time, it sets a to 0
                                        ;also sets the first spot hit to the current spot
        ld      hl,temp
        dec     (hl)
        jr      z,setDirZero
        ld      de,(AIy1)
        ld      (AIy2),de
        ld      hl,AIdir
        ld      a,(hl)
        cp      1
        jr      z,raiseDir
        cp      2
        jr      z,lowerDir
        cp      3
        jr      z,raiseDir
lowerDir:
        dec     a
        ld      (hl),a
        ret
RaiseDir:
        inc     a
        ld      (hl),a
        ret
setDirZero:
        xor     a
        ret

goDirection:                            ;increases d or e (x,y) depending on direction (a)
                                        ;if it will go off grid it sets zero flag and leaves
        dec     a
        jr      z,oneRight
        dec     a
        jr      z,oneLeft
        dec     a
        jr      z,oneUp
oneDown:
        ld      a,e
        cp      9
        ret     z                       ;don't move if it will go off grid
        inc     e
        ret
oneUp:
        inc     e
        dec     e
        ret     z                       ;don't move if it will go off grid
        dec     e
        ld      a,1
        or      a                       ;making sure zero flag is reset
        ret
oneLeft:
        inc     d
        dec     d
        ret     z                       ;don't move if it will go off grid
        dec     d
        ld      a,1
        or      a                       ;making sure zero flag is reset
        ret
oneRight:
        ld      a,d
        cp      9
        ret     z                       ;don't move if it will go off grid
        inc     d
        ret




youlose:
        ld      a,3
        call    sendbytetios
youloseAI:
        ld      de,21*256+65
        ld      (penCol),de
        ld      hl,youlosestr
        bcall(_VPutS)
        call    ifastcopy
        call    waitforkey
        jr      quit

youwin:
        ld      a,1
        ld      (temp),a
        call    drawmyships
        call    ifastcopy
        ld      de,21*256+65
        ld      (penCol),de
        ld      hl,youwinstr
        bcall(_VPutS)
        call    ifastcopy
        call    waitforkey
        
quit:                                   ;I guess this is kinda pointless now..
                                        ;but if quitting ever has to do more.. i'll be ready
        ;ret
        jp      start


;---------------= Routines =--------------

checklink:
        in      a,(2)
        rla
        jr      nc,notSE                ;ok is it a TI83+ or TI83+SE?
SE:
        in      a,(9)                   ;ok it's an SE so I check the link assist
        and     %00011000
        ret
notSE:
        in      a,(0)                   ;it's not an SE so I check the DBUS directly
        and     %00000011
        cp      %00000011
        ret
        
drawgrid:                               ;draws the 10x10 grid to the screen and buffer
        ld      hl,1*256+1
        ld      de,61*256+1
        ld      b,11
horizlinesloop:                         ;loop drawing 11 horizontal lines
        push    bc
        push    hl
        push    de
        call    fastlineb
        pop     de
        pop     hl
        pop     bc
        ld      a,l
        add     a,6
        ld      l,a
        ld      e,l
        djnz    horizlinesloop

        ld      hl,1*256+1
        ld      de,1*256+61
        ld      b,11
vertlinesloop:                          ;loop drawing 11 vertical lines
        push    bc
        push    hl
        push    de
        call    fastlineb
        pop     de
        pop     hl
        pop     bc
        ld      a,h
        add     a,6
        ld      h,a
        ld      d,h
        djnz    vertlinesloop
        call    ifastcopy
        ret
        
drawship:                               ;draws the ship to the buffer
                                        ;inputs: al = xy
        ld      b,5
        ld      c,4
        ld      ix,ship
        call    ilsprite
        ret

blinkspot:                              ;draws the spot to the screen and buffer
                                        ;and delays. will return on a keypress.
        ld      hl,(tspoty)
        ld      a,h
        call    loctopix
        ld      b,5
        ld      ix,spot
        call    isprite
        call    ifastcopy
        ld      a,(spotstatus)
        cpl
        ld      (spotstatus),a
        ld      bc,$FFFF
blinkloop:
        ld      a,$FF                   ;yea this whole chunk is
        out     (1),a                   ;checking for keypresses
        ld      a,Group1                ;if there is any then it
        out     (1),a                   ;returns back to get it
        in      a,(1)
        ret     nz
        
        dec     bc
        ld      a,b                     ;loop back until BC = 0
        or      c
        jr      nz,blinkloop
        ret
        
drawpiece:                              ;draws a ship piece to buffer
                                        ;input: hl = xy  de = direction and length
        ld      a,1
        ld      (setready),a
        ld      hl,(spoty)
        ld      de,(shiplength)
        inc     d
        dec     d
        jr      z,loadleft              ;check direction of the piece
        ld      ix,toppiece             ;if vertical load the top sprite
        jr      drawit                  ;go draw it
loadleft:
        ld      ix,leftpiece            ;but if it's horizonal load the left sprite
drawit:
        push    hl
        push    de
        ex      de,hl
        ld      hl,gamearea1
        ld      c,0
        call    gameareamem
        and     %00001000
        jr      z,skipsetnotready
        xor     a
        ld      (setready),a
skipsetnotready:
        pop     de
        pop     hl
        
        ld      a,h
        push    hl
        call    loctopix
        ld      b,5
        push    de
        call    isprite
        pop     de
        pop     hl
        dec     e                       ;decrease the length by 1
        ret     z                       ;leave if it already drew the last piece
        inc     d
        dec     d
        jr      z,incx                  ;check direction of the piece
        inc     l                       ;if vertical move the position down
        ld      a,e
        cp      1
        jr      z,loadbottom            ;if last piece, load the bottom sprite
        ld      ix,spot
        jr      drawit                  ;loop back to draw
incx:
        inc     h                       ;if horizontal move the position right
        ld      a,e
        cp      1
        jr      z,loadright             ;if last piece, load the right sprite
        ld      ix,spot
        jr      drawit                  ;loop back to draw
loadbottom:
        ld      ix,bottompiece
        jp      drawit
loadright:
        ld      ix,rightpiece
        jp      drawit
        
loctopix:                               ;al*6+2   destroys h and b
        add     a,a
        ld      b,a
        add     a,a
        add     a,b
        add     a,2
        ld      h,a
        ld      a,l
        add     a,a
        ld      b,a
        add     a,a
        add     a,b
        add     a,2
        ld      l,a
        ld      a,h
        ret
        
gameareamem:                            ;saves byte in a to (d,e) if c is 1. gets if 0
                                        ;hl is the location of 0,0 in the memory
        push    bc
        ld      b,e
        inc     e
        dec     e
        jp      z,setx
        push    de
        ld      de,10
ysaveloop:
        add     hl,de
        djnz    ysaveloop
        pop     de
setx:
        ld      b,0
        ld      c,d
        add     hl,bc
        pop     bc
        inc     c
        dec     c
        jp      z,getspot
        ld      (hl),a
        ret
getspot:
        ld      a,(hl)
        ret
        
waitforkey:
        bcall(_GetCSC)
        or      a
        jr      z,waitforkey
        ret
        
        
        


;---------------= Sprites and Text =--------------

titlestr:       .db "BattleShip!",0
authorstr:      .db "By Mike Bruno",0
startstr:       .db "2nd - Start",0
quitstr:        .db "Mode - Quit",0
waitstr:        .db "Waiting...",0
hitstr:         .db "Hit!",0
missstr:        .db "Miss!",0
sunkstr:        .db "and Sink!",0
youwinstr:      .db "You Win!",0
youlosestr:     .db "You Lose!",0
playersstr:     .db "Alpha - Players:",0
players:        .db "2",0

ship:
        .db %00000000, %00000010, %00000000, %00000000
        .db %00000000, %00000011, %00100000, %00000000
        .db %10000000, %00111111, %11111110, %00000100
        .db %11111111, %11111111, %11111111, %11111100
        .db %01111111, %11111111, %11111111, %11111000

spot:
        .db %11111000
        .db %11111000
        .db %11111000
        .db %11111000
        .db %11111000
        
toppiece:
        .db %00100000
        .db %01110000
        .db %11111000
        .db %11111000
        .db %11111000

bottompiece:
        .db %11111000
        .db %11111000
        .db %11111000
        .db %01110000
        .db %00100000

rightpiece:
        .db %11100000
        .db %11110000
        .db %11111000
        .db %11110000
        .db %11100000

leftpiece:
        .db %00111000
        .db %01111000
        .db %11111000
        .db %01111000
        .db %00111000

hit:
        .db %00000000
        .db %01110000
        .db %01010000
        .db %01110000
        .db %00000000
        
miss:
        .db %10001000
        .db %01010000
        .db %00100000
        .db %01010000
        .db %10001000
        
        .end
